﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Windows;

namespace TestMenu.Model
{
    public class MenuBase
    {
        public MenuItemInfo menuItemInfo;
        public MenuBase()
        {

        }

        public MenuBase(int menuId)
        {
            this.menuItemInfo = BaseLogic.GetInstanse().MenuList.Find(p => p.MenuId == menuId);
        }

        public virtual void Excute(TabControl tabControl)
        {
            if (!string.IsNullOrEmpty(this.menuItemInfo.FormName))
            {
                if (this.menuItemInfo.OpenType == (int)OpenType.NewForm)      //新窗口打开
                {
                    Window billForm = System.Reflection.Assembly.GetExecutingAssembly().CreateInstance(this.menuItemInfo.FormName, false) as Window;
                    billForm.ShowDialog();
                    billForm.Close();
                }
                else if (this.menuItemInfo.OpenType == (int)OpenType.TabForm)  //Tab页打开
                {
                    CloseableTabItem tab = null;
                    // TabItem tab = null;
                    if (tabControl.Items.Count > 0)
                    {
                        foreach (CloseableTabItem item in tabControl.Items)
                        {
                            if (item.Name == this.menuItemInfo.Name)
                            {
                                tab = item;
                                break;
                            }
                        }
                    }
                    if (tab == null)
                    {
                        var v = System.Reflection.Assembly.GetExecutingAssembly().CreateInstance(this.menuItemInfo.FormName, false);
                        //tab = new TabItem();
                        tab = new CloseableTabItem();
                        tab.Name = this.menuItemInfo.Name;
                        tab.Header = this.menuItemInfo.HeaderText;
                        //tab.Tag = this.menuItemInfo.MenuName;
                        tab.Content = v;

                        tabControl.Items.Add(tab);
                    }
                    tab.IsSelected = true;
                }
            }
        }
    }
}
