﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml.Serialization;

namespace TestMenu.Model
{
    public class MenuData
    {
        public List<MenuItemInfo> menuItemList = null;

        private const string resName = "MenuInfo";

        public MenuData()
        {
            this.menuItemList = new List<MenuItemInfo>();
            this.SerializerByStream(resName);
        }

        private void SerializerByStream(string value)
        {
            if (!String.IsNullOrEmpty(value))
            {
                string strXml = TestMenu.Properties.Resources.ResourceManager.GetObject(resName) as string;
                if (!String.IsNullOrEmpty(strXml))
                {
                    Stream stream = new MemoryStream(System.Text.UTF8Encoding.UTF8.GetBytes(strXml));
                    if (stream.Length > 0)
                    {
                        XmlSerializer serializer = new XmlSerializer(typeof(MenuInfo));
                        try
                        {
                            MenuInfo menuInfo = (MenuInfo)serializer.Deserialize(stream);
                            if (menuInfo != null && menuInfo.MenuItemList.Count > 0)
                            {
                                foreach (MenuItemInfo info in menuInfo.MenuItemList)
                                {
                                    this.menuItemList.Add(info);
                                    AddChild(info);
                                }
                            }
                        }
                        catch
                        {
                            throw new Exception("Can't serializer '" + value + "' stream");
                        }
                    }
                }
            }
        }

        private void AddChild(MenuItemInfo item)
        {
            if (item.MenuItemList != null && item.MenuItemList.Count > 0)
            {
                foreach (MenuItemInfo info in item.MenuItemList)
                {
                    this.menuItemList.Add(info);
                    AddChild(info);
                }
            }
        }
    }
}
